=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: bcachefs-tools
-Maintainer: Jonathan Carter <jcc@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jonathan Carter <jcc@debian.org>
 Section: utils
 Priority: optional
 Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
+               cargo,
                pkg-config,
                python3-docutils,
                python3-pytest,
