=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
# Do not build rust code (dependencies currently unmet)
export NO_RUST=-true

PREFIX := /usr
ROOT_SBINDIR := /usr/sbin

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)


ifeq ($(DEB_BUILD_ARCH),amd64)
    DEB_BUILD_MAINT_OPTIONS += optimize=-lto
endif

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- "PREFIX=$(PREFIX)" "ROOT_SBINDIR=$(ROOT_SBINDIR)"

override_dh_auto_test:
