=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/bcachefs-tools_$1\.tar\.gz/ \
  https://github.com/koverstreet/bcachefs-tools/tags .*/v?(\d\S+)\.tar\.gz
